package de.hdm_stuttgart.battlearena.Model.Multiplayer.TestServer;

import de.hdm_stuttgart.battlearena.Model.Multiplayer.GameServer;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.net.*;
import java.io.*;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class Server {

    private static final Logger log = LogManager.getLogger(Server.class);
    private ServerSocket serverSocket;
    private static int px;
    private static int py;

    public static void main(String[] args) throws IOException {
        Server server = new Server();
        log.info("server starting...");
        server.start("localhost",4444);
    }

    public void start(String lolcalhost, int port) throws IOException {
        serverSocket = new ServerSocket(port);
        log.info("server started!");
        while (true)
            new ServerHandler(serverSocket.accept()).start();
    }

    public void stop() throws IOException {
        serverSocket.close();
    }

    // EchoClientHandler class in the Server

    private static class ServerHandler extends Thread {
        private Socket clientSocket;
        private PrintWriter out;
        private BufferedReader in;

        public ServerHandler(Socket socket) {
            this.clientSocket = socket;
        }

        public void run() {
            ScheduledExecutorService executorService = Executors.newSingleThreadScheduledExecutor();

            executorService.scheduleAtFixedRate(() -> {
                try {
                    BufferedReader localIn = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
                    PrintWriter localOut = new PrintWriter(clientSocket.getOutputStream(), true);

                    String inputLine = localIn.readLine();

                    if (inputLine != null) {
                        if (inputLine.startsWith("x:")) {
                            int receivedX = Integer.parseInt(inputLine.substring(2));
                            px = receivedX;

                            localOut.println(inputLine);
                            localOut.flush();
                            log.info("Current X and Y: " + px + " / " +  py);
                            log.info("Sent response to client: " + receivedX);

                        } else if (inputLine.startsWith("y:")) {
                            int receivedY = Integer.parseInt(inputLine.substring(2));
                            py = receivedY;

                            localOut.println(inputLine);
                            localOut.flush();
                            log.info("Current X and Y: " + px + " / " +  py);
                            log.info("Sent response to client: " + receivedY);
                        }

                    }
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }, 0, 250, TimeUnit.MILLISECONDS);
        }

    }

}
